<?php

namespace Lc\ShopBundle\Form;

use CKSource\Bundle\CKFinderBundle\Form\Type\CKFinderFileChooserType;
use Doctrine\ORM\EntityManagerInterface;
use FOS\CKEditorBundle\Form\Type\CKEditorType;
use Lc\ShopBundle\Context\OrderProductInterface;
use Lc\ShopBundle\Context\ProductFamilyInterface;
use Lc\ShopBundle\Context\ProductInterface;
use Lc\ShopBundle\Context\TaxRateInterface;
use Lc\ShopBundle\Services\Utils;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;
use function PHPSTORM_META\type;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class OrderProductType extends AbstractType
{
        protected $em;
        protected $utils;

        public function __construct(EntityManagerInterface $entityManager, Utils $utils)
        {
                $this->em = $entityManager;
                $this->utils = $utils;
        }

        public function buildForm(FormBuilderInterface $builder, array $options)
        {


                $productClass = $this->em->getClassMetadata(ProductInterface::class);

                $builder->add('product', EntityType::class, array(
                        'class' => $productClass->name,
                        'placeholder'=> '',

                        'choice_label'=> function($product){
                                return $product->getProductFamily()->getTitle() . ' - ' . $product->getTitle();
                        }
                ));
                $builder->add('quantity', NumberType::class, array(
                        'label' => 'Quantité',
                        'attr' => [
                                'append_html' => 'g'
                        ]
                ));

        }

        public function configureOptions(OptionsResolver $resolver)
        {
                $resolver->setDefaults([
                        'data_class' => $this->em->getClassMetadata(OrderProductInterface::class)->getName(),
                ]);
        }
}
