<?php

namespace Lc\ShopBundle\Form;

use CKSource\Bundle\CKFinderBundle\Form\Type\CKFinderFileChooserType;
use Doctrine\ORM\EntityManagerInterface;
use FOS\CKEditorBundle\Form\Type\CKEditorType;
use Lc\ShopBundle\Context\ProductFamilyInterface;
use Lc\ShopBundle\Context\ProductInterface;
use Lc\ShopBundle\Context\TaxRateInterface;
use Lc\ShopBundle\Services\Utils;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;
use function PHPSTORM_META\type;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ProductType extends AbstractType
{
        protected $em;
        protected $utils;

        public function __construct(EntityManagerInterface $entityManager, Utils $utils)
        {
                $this->em = $entityManager;
                $this->utils = $utils;
        }
        public function buildForm(FormBuilderInterface $builder, array $options)
        {


                $builder->add('title', TextType::class, array(
                        "required" => false
                )) ;


                $builder->add('quantity', NumberType::class, array(
                        'label' => 'Quantité',
                        'required'=>false,
                        'attr' => [
                                'append_html' => 'g'
                        ]
                ));

                $builder->add('unit', ChoiceType::class, array(
                        'label' => 'Unité',
                        "required" => false,
                        'choices' => $this->utils->getUnitsListFormatedForType()
                ));


                $builder->add('price', NumberType::class, array(
                        'label' => 'Prix',
                        "required" => false
                ));

                $builder->add('priceWithTax', NumberType::class, array(
                        'label' => 'Prix TTC',
                        'required' => false,
                        'mapped' => false
                ));

                $builder->add('buyingPrice', NumberType::class, array(
                        'label' => 'Prix d\'achat',
                        'required'=>false
                ));

                $builder->add('buyingPriceWithTax', NumberType::class, array(
                        'label' => 'Prix d\'achat TTC',
                        'required' => false,
                        'mapped' => false
                ));
                $builder->add('multiplyingFactor', NumberType::class, array(
                        'label' => 'Coefficiant de multiplication',
                        'mapped'=>false,
                        'required'=>false
                ));

                $builder->add('availableQuantity', NumberType::class, array(
                        'label' => 'Quantité disponible',
                        'required' => false,
                ));

                $builder->add('availableQuantityDefault', NumberType::class, array(
                        'label' => 'Quantité disponible',
                        'required' => false,
                ));

                $builder->add('expirationDate', DateType::class,array(
                        'required' => false,
                        'widget' => 'single_text'
                ));
                $builder->add('position', HiddenType::class);

        }

        public function configureOptions(OptionsResolver $resolver)
        {
                $resolver->setDefaults([
                        'data_class' => $this->em->getClassMetadata(ProductInterface::class)->getName(),
                ]);
        }
}
